Zen API

- Home
- Help Topics
- Types by Category
- All Types
- Files

All Classes Files Functions Variables Typedefs Macros Groups Pages
Public Member Functions
kHttpServerResponse Class Reference
kApi/Io

## Description

Supports HTTP server response formatting.

Inheritance diagram for kHttpServerResponse:

## Public Member Functions
kStatus | kHttpServerResponse_AddHeader (kHttpServerResponse response, const kChar *name, const kChar *value)
| Adds a header value to the response. More...
kStatus | kHttpServerResponse_BeginWriteChunk (kHttpServerResponse response, k64u length, kStream *stream)
| Begins writing a chunk-encoded message body segment. More...
kStatus | kHttpServerResponse_BeginWriteContent (kHttpServerResponse response, k64u length, kStream *stream)
| Begins writing a simple message body. More...
kStatus | kHttpServerResponse_SetClosed (kHttpServerResponse response, kBool closed)
| Instructs the HTTP server to close this connection when message processing is complete. More...
kStatus | kHttpServerResponse_SetHeader (kHttpServerResponse response, const kChar *name, const kChar *value)
| Sets the value of a header in the response. More...
kStatus | kHttpServerResponse_SetReason (kHttpServerResponse response, const kChar *reason)
| Sets the HTTP status description associated with this response. More...
kStatus | kHttpServerResponse_SetStatus (kHttpServerResponse response, kHttpStatus status)
| Sets the HTTP status code associated with this response. More...
kStatus | kHttpServerResponse_SetVersion (kHttpServerResponse response, kVersion version)
| Sets the version associated with this HTTP response. More...
kAlloc | kObject_Alloc (kObject object)
| Gets the memory allocator associated with this object. More...
kStatus | kObject_Clone (kObject *object, kObject source, kAlloc allocator)
| Constructs a new object by copying an existing object, including any aggregated child elements. More...
kStatus | kObject_Destroy (kObject object)
| Destroys the object. More...
kStatus | kObject_Dispose (kObject object)
| Destroys the object and any aggregated child elements. More...
kBool | kObject_Equals (kObject object, kObject other)
| Determines whether the object is equal to another object. More...
kSize | kObject_HashCode (kObject object)
| Gets a hash code representing the state of this object. More...
kBool | kObject_Is (kObject object, kType type)
| Determines whether this object is an instance of the specified type. More...
kBool | kObject_IsShared (kObject object)
| Reports whether the object is currently shared (reference count greater than one). More...
kStatus | kObject_SetPool (kObject object, kObjectPool pool)
| Sets the object pool associated with this object. More...
kStatus | kObject_Share (kObject object)
| Increments the reference count associated with this object. More...
kSize | kObject_Size (kObject object)
| Estimates the memory consumed by this object, including any aggregated child elements. More...
kType | kObject_Type (kObject object)
| Returns the type of the object. More...

## Member Function Documentation

kStatus kHttpServerResponse_AddHeader | ( | kHttpServerResponse | response,
|  | const kChar * | name,
|  | const kChar * | value
| ) |  |

Adds a header value to the response.

Headers that can be determined from the information provided in other functions (e.g. 'Content-Length', 'Transfer-Encoding', 'Connection') will be generated automatically and should not normally be provided via this function.

If multiple headers with the same field name are provided, each subsequent header value will be added to the previous header values (comma-separated).

Leading headers should be added prior to writing the message body. Trailing headers can be generated by calling this function after writing at least one chunk-encoded body segment.

Parameters

  response | Response object.
  name | Header field name.
  value | Header field value.

Returns
  Operation status.

kStatus kHttpServerResponse_BeginWriteChunk | ( | kHttpServerResponse | response,
|  | k64u | length,
|  | kStream * | stream
| ) |  |

Begins writing a chunk-encoded message body segment.

Use the stream provided by this function to write the message chunk. Call this function with a length of zero to signify that writing is complete.

Use of this function will automatically add the 'Transfer-Encoding: chunked' header.

Parameters

  response | Response object.
  length | Length of the message chunk, in bytes.
  stream | Receives a reference to a stream object that should be used to write the message chunk.

Returns
  Operation status.

kStatus kHttpServerResponse_BeginWriteContent | ( | kHttpServerResponse | response,
|  | k64u | length,
|  | kStream * | stream
| ) |  |

Begins writing a simple message body.

Use the stream provided by this function to write the message body.

Use of this function will automatically add the 'Content-Length' header.

Parameters

  response | Response object.
  length | Total length of the message body, in bytes.
  stream | Receives a reference to a stream object that should be used to write the message body.

Returns
  Operation status.

kStatus kHttpServerResponse_SetClosed | ( | kHttpServerResponse | response,
|  | kBool | closed
| ) |  |

Instructs the HTTP server to close this connection when message processing is complete.

This function can only be called prior to writing the message body.

Use of this function will automatically add the 'connection: closed' header.

Parameters

  response | Response object.
  closed | kTRUE to close the connection; kFALSE otherwise.

Returns
  Operation status.

kStatus kHttpServerResponse_SetHeader | ( | kHttpServerResponse | response,
|  | const kChar * | name,
|  | const kChar * | value
| ) |  |

Sets the value of a header in the response.

Headers that can be determined from the information provided in other functions (e.g. 'Content-Length', 'Transfer-Encoding', 'Connection') will be generated automatically and should not normally be provided via this function.

Leading headers should be added prior to writing the message body. Trailing headers can be generated by calling this function after writing at least one chunk-encoded body segment.

Parameters

  response | Response object.
  name | Header field name.
  value | Header field value.

Returns
  Operation status.

kStatus kHttpServerResponse_SetReason | ( | kHttpServerResponse | response,
|  | const kChar * | reason
| ) |  |

Sets the HTTP status description associated with this response.

If a custom description is not provided, a default description based on the status code will be sent.

This function can only be called prior to writing the message body.

Parameters

  response | Response object.
  reason | HTTP status description.

Returns
  Operation status.

kStatus kHttpServerResponse_SetStatus | ( | kHttpServerResponse | response,
|  | kHttpStatus | status
| ) |  |

Sets the HTTP status code associated with this response.

By default, status code 200 (OK) is assumed.

This function can only be called prior to writing the message body.

Parameters

  response | Response object.
  status | HTTP status code.

Returns
  Operation status.

kStatus kHttpServerResponse_SetVersion | ( | kHttpServerResponse | response,
|  | kVersion | version
| ) |  |

Sets the version associated with this HTTP response.

By default, version 1.1 is assumed.

This function can only be called prior to writing the message body.

Parameters

  response | Response object.
  version | Message version.

Returns
  Operation status.

kAlloc kObject_Alloc | ( | kObject | object | ) |
| inherited

Gets the memory allocator associated with this object.

Most objects are constructed with an allocator, which is used to allocate the memory required by the object. Objects retain a reference to this allocator to enable further allocations and to free memory when the object is destroyed.

Parameters

  object | Object.

Returns
  Memory allocator.

See also
  kAlloc, kObject_Alloc_

kStatus kObject_Clone | ( | kObject * | object,
|  | kObject | source,
|  | kAlloc | allocator
| ) |  |
| inherited

Constructs a new object by copying an existing object, including any aggregated child elements.

If the source object is an object collection (e.g. kArrayList<kString>), any aggregated child objects are also cloned. In this case, the kObject_Dispose method can be used to free the cloned collection and its associated elements.

This method will fail if the source object (or an aggregated child element) does not support cloning.

Parameters

  object | Receives the constructed object.
  source | Source object.
  allocator | Memory allocator (or kNULL for default).

Returns
  Operation status.

See also
  kObject_Dispose

kStatus kObject_Destroy | ( | kObject | object | ) |
| inherited

Destroys the object.

The kObject_Destroy method destroys the object itself and any resources that are owned by the object. See Object Destruction for more information.

When an object is destroyed (or disposed), its reference count is decremented. The object is only truly destroyed when the reference count reaches zero. See Reference Counting for more information.

Parameters

  object | Object (or kNULL).

Returns
  Operation status.

See also
  Object Destruction, Reference Counting

kStatus kObject_Dispose | ( | kObject | object | ) |
| inherited

Destroys the object and any aggregated child elements.

The kObject_Dispose method destroys the object itself, any resources that are owned by the object, and if the object represents a collection of objects, any child objects in the collection. See Object Destruction for more information.

When an object is destroyed (or disposed), its reference count is decremented. The object is only truly destroyed when the reference count reaches zero. See Reference Counting for more information.

Parameters

  object | Object (or kNULL).

Returns
  Operation status.

See also
  Object Destruction, Reference Counting

kBool kObject_Equals | ( | kObject | object,
|  | kObject | other
| ) |  |
| inherited

Determines whether the object is equal to another object.

By default, objects are compared by reference; objects are considered equal if the given handles refer to the same object instance. However, some classes override the Equals method to provide a more meaningful comparison (e.g. kString).

Parameters

  object | Object.
  other | Object for comparison.

Returns
  kTRUE if the objects are equal.

kSize kObject_HashCode | ( | kObject | object | ) |
| inherited

Gets a hash code representing the state of this object.

By default, objects return a hash code based on the object handle value. However, some classes override the HashCode method to provide a more useful hash (e.g. kString).

Parameters

  object | Object.

Returns
  Hash code.

kBool kObject_Is | ( | kObject | object,
|  | kType | type
| ) |  |
| inherited

Determines whether this object is an instance of the specified type.

This function compares the type of this object with the given type. An object is considered to be an instance of a given type if a) the type represents a class and this object inherits from (or instantiates) that class, or b) the type represents an interface and this object implements the interface.

Parameters

  object | Object.
  type | Type.

Returns
  kTRUE if the object is of the specified type; otherwise kFALSE.

See also
  kObject_Is_, kType_Is

kBool kObject_IsShared | ( | kObject | object | ) |
| inherited

Reports whether the object is currently shared (reference count greater than one).

Objects are initialized with a reference count of one. The kObject_Share method can be used to increment the reference count. The kObject_Destroy and kObject_Dispose methods decrease the reference count, and when the reference count reaches zero, the object is actually destroyed/disposed.

This method can be used to determine if the reference count of an object is currently greater than one.

This method is thread-safe.

Parameters

  object | Object.

Returns
  kTRUE if the object is shared; kFALSE otherwise.

See also
  Reference Counting, kObject_Share

kStatus kObject_SetPool | ( | kObject | object,
|  | kObjectPool | pool
| ) |  |
| inherited

Sets the object pool associated with this object.

Object pools can be used to implement custom lifecycle management. If an object has an assigned pool, then the kObjectPool_Reclaim method will be called just prior to destruction, to provide an opportunity for the object to be reclaimed.

Parameters

  object | Object.
  pool | Pool object (or kNULL to clear the pool assignment).

Returns
  Operation status.

kStatus kObject_Share | ( | kObject | object | ) |
| inherited

Increments the reference count associated with this object.

This method is thread-safe.

Parameters

  object | Object.

Returns
  Operation status.

See also
  reference-counting

kSize kObject_Size | ( | kObject | object | ) |
| inherited

Estimates the memory consumed by this object, including any aggregated child elements.

This method can be optionally overridden by kObject-derived classes to report the amount of memory consumed by an object. The default implementation reports only the size of the class instance (additional allocations performed by the class are excluded).

Parameters

  object | Object.

Returns
  Object size, in bytes.

kType kObject_Type | ( | kObject | object | ) |
| inherited

Returns the type of the object.

Each object is an instance of a specific class type. The type handle returned by this function can be used to learn about the class.

Parameters

  object | Object.

Returns
  Type.

See also
  kType, kObject_Type_

The documentation for this class was generated from the following file:

- Io/kHttpServerResponse.h